Hi all!

On May 13, 12:35 MSK, Tinkoff Challenge — Final Round will be held. Standings of the official finalists are availiable here.

The authors of the round are me (zscoder, Zi Song Yeoh), AnonymousBunny (Sreejato Kishor Bhattacharya), hloya_ygrt (Yury Shilyaev).

Special thanks to KAN (Nikolay Kalinin) for coordinating the round, winger (Vladislav Isenbaev) and AlexFetisov (Alex Fetisov) for testing the problems. Also, thanks to MikeMirzayanov (Mike Mirzayanov) for the Codeforces and Polygon system.

There are seven problems and the duration is two hours. Scoring will be announced before the round.

Top 20 participants of the Elimination Round will compete in the Tinkoff Office.

The round is **rated**. Division 1 and Division 2 will have the same problemset with seven problems.

We hope everyone will find interesting problems and get high rating!

UPD : Scoring Distribution : 500 — 1000 — **1750** — 2000 — 2500 — **2750** — 3500

UPD2 : The editorial is out!

UPD3 : Congratulations to the top 10 :

Is everyone allowed to participate in this round, besides not having participated in the previous round?

Yes, you can treat it as a normal Div. 1 + Div. 2 round.

Please update the title in the contest tab including that it is a Div 1 + Div 2 rated combined round.

Isn't timing unusual from normal codeforce rounds ? .... Do not want to miss it but have semester exam :(

probably the onsite contest will be held at the same time.

Try to do the paper in 1 hour :P

did :p

:|

SpoilerThank you)

Like someone said it's probably held at the same time as the on-site contest, and different countries hold APIO at different times so it's hard to avoid anyway.

zscoder Congratulations for becoming red :D

I remember last time you prepared a round you was purple

Auto comment: topic has been updated by zscoder (previous revision, new revision, compare).Are the finalists gonna be in one room?

Yes

You are talking about the codeforces room, in which people can hack each other, right? :)

Yes

And will finalists see the standings of the round, or only each other?

Yes for the third time :D

Are you a finalist?

No, I'm just curious, lol

P.S. You can switch to russian version to see finalists's list

Just come on!

..

I have an exam, but I'll participate :"D

You truly are living on the edge! I wish I could be as bold as you...

Hopefully,there could be data structures related problems in this challenge......

hopefully there will be short statements !!!

zscoder is this the round you mentioned here ?

Yes :)

Codeforces determining whether or not there will be a delay

Hope there won't be delay before the contest.

Is the round rated?

Some people were hoping if they would participate in a round held by tourist they would become so strong competitive programmers as tourist do. So, maybe that round can teach us how to handle serious business

1 hour delaying would be better...

Hot Day and cool codeforces!

Better Time of contest for us.

I predict there will be a question on permutations.

i predict there will atleast be a question on dp.

I predict D will be a Graph problem as the two previous contests that made by zscoder !

Your predict is correct !!!

I predict that problem A will be easy

I predict Problem E will be tough

I predict that problem C will be easier than previous contest.

I predict that problem B will be easy.

I'm esemoooooo.

Hi, esmoooooo.

I just spotted this lucky cheater sepanta I hope that Mike will take care of him.

yeah i saw too -_-

i didnt know someone already posted it or i would not have posted it....

And sepanta is blue now :|

I think he wants to avenge for his comments xD

31 hacks on the same one!! What a cheater!!

He is too lucky to enter the same room with his another fake account !

my solution for problem C is showing "running test case 5" for the past 10mins.

i got it now

I glare on the statement. It looks so easy. Then I see success ratio. It is about 1./2. What a nice confusing problem!

I am waiting for explanation why it was not possible just to get Problem C AC at the first attempt.

456

123

answer?

162

first guy moves first

Just greedy strategy. 615

Wow! Only NOW I understood the statement. Excuse me. I was careless. I thought Oleg always has nice set of letters.

Is it 435?

ohh.. unclear

Thank you very much!

Nope, you're wrong. If the first guy plays 4 in the middle, then the second guy will play 3 at the last to get the longest lexicographic string. If that happens then first player has no choice but to play 5 which is clearly not the best case. Best case is 435.

I agree with you, and then write it in this way, but i get a WA.

It's 435

435

Basically there will be 3 numbers in the string, so first player will use 4 and 5, and second player will use 3.

First player wants to minimize the result, so he will obviously put the 4 before the 5. Since it is better for him to have the 3 put in the front, and since the other player is going to put it at the end because 4 > 3 and 5 > 3, he puts 5 in the last spot.

Then the second player puts the 3 in the middle spot, and the 4 goes in the last remaining spot, at the beginning.

Therefore, answer is 435, according to me.

Isn't the output for testcase bcdef abbbc be bccbd ?

My code (which got Accepted) says bccdb.

how ? how much i got is first oleg will place b at first position then igor will place c at 2nd position . now, oleg can place d at last position , now igor will place b at fourth position and then oleg will place c at 3. so the resultant will be bccbd ?

sry got it my bad :(

How to solve B?

P.S. I feel like either A or B is getting harder than C nowadays. Last contest, I solved C easily, but unable to solve A. Today, I solved C (not so easily), but don't have any idea at all to solve B. It feels just weird...

B was easier if you looked for which height should you cut, in order to find a triangle of area i/max_area

binary search, but I'm sure there is some equation to solve it in linear time

Binary search the height? But how to compute the area of such heights? Since we don't know the length of base of some heights

In similar triangles, we have that the ratio of base/height has to be the same, so you can find the base for a height doing, heightX/heightB, where heightX is the height that you wanna know the base, and heightB is the full base height(the value of the height of the complete triangle).

suppose that b1 is the base with height h1, b = 1

b1 / b = h1 / h

starting from apex if we join the pieces we get a isosceles triangle . then we get relation of base and height using tan(apex angle) Finally we get height of ith cut hi = sqrt(i/n)*h

So much geometrical insights... Thanks

I guess B is a pure mathematical problem. The k-th answer (indexed from 1) should be sqrt(k/n) * h.

I feel stupid using trapezium formula now...

I am finding area of each part and setting difference between area(x[i-1) and area(x[i]) to that number. Used Decimal precision 50. Hope is would be enough...

How to determine how long would my program with prec=X run on that servers for any X?

O(1) solution using some geometry properties.

You can determine a single height in O(1), but the total complexity will be O(n)

Yeah sure I meant the single height ,ofCourse it's O(n) overall.

I think B was very easy math. You got lucky to solve C on first attempt, because it was little tricky — check the successful ratio — 659/1914. Anyway, nice problems, hope you agree.

You can compute Tan (a) =h/0.5, and then x*x*tan (a) =i*area., where I represents the first I triangle, and X is half the base of each triangle.

How to do F? I hope expected solution is not

I had N^1.5*10, didn't passed 16'th test. But I hope it can be optimized in the way to pass.

I think NlogN*10 should pass. Just hold the information for lazy propagation as a permutation: all digits i became P[i]. Unfortunately, somehow, in an hour I've got 15 WAs, TLEs and runtime errors. However, it makes sense to work, it's just that I had a lot of bugs. You can propagate something like P[son][i] becomes P[node][P[son][i]]

LE: of course it got AC immediatly after the contest

Implementation is rekt

Neah, it was easy. I don't know what happened to me. I used to have 0 bugs till a week ago and now every source that I code has the stupidest bugs ever. I had the right idea just after half of the submission I made: initially I though that it's enough to hold all relevant moves on some node and then traverse them and push them to the sons, as I thought there are at most 10 relevant moves (through relevant I mean they change something). Ohh, and of course I spent about 10 minutes to find out that there could be operations that change digit x in x... I think this should've been mentioned. Anyway, the problems were nice but I hurried a lot and wasn't careful because I had a lot of WAs (even on C, I still have no idea what I'm doing wrong as I have a complete proof of my solution, even though I think I overcomplicated the problem)

That was a joke

Damn, my solution passes if I switch to size of block exactly sqrt(N) and submit on MS C++ instead of GNU. Such a pain.

Can someone please explain C?

xyz abc => answer is xcy

Yeah I came up with a few cases in contest but couldn't figure out a way to make it consistent, could you elaborate?

The first guy will use only (n+1)/2 characters and second one will use n/2. So keep optimal character set for both of them. Now,

Think about four cases: In his turn,

1. Player 1, has bad set, what should he do?

2. Player 1, has good set, what should he do?

3. Player 2, has bad set, what should he do?

4. Player 2, has good set, what should he do?

HintsIf I have good set, I will put my best character at the first. otherwise, I will put my worst character at the last.

How do you classify good or bad sets for both players ?

If you are trying to make the string smaller, than, you have a good set if you have at least one character which is smaller than all of your opponents. and The other way is true.

thanks a lot

I am really feeling bad on seeing how easily it can be solved !!! I am just too stupid :(

The 1750 points confused me in the first time. Maybe you have a bad day. Better luck next time.

Actually, wxyz abcd is more interesting. Answer is dwcx, while the most naive strategy will output wdxc.

It should be xyc,isn't it?

No, it should be xcy as first guy replaces '?' such that new name would be ??y. Second person have to place 'c' in the middle. Thus we can get xcy as optimal answer.

thank you.

So first observation is that you will only use the smallest (n+1)/2 elements of the first string and n/2 largest elemets from the second. If all chars from s1 are smaller then it would be easy, you would simply use a greedy to fill the word putting it at the leftmost position. Now, lets have the case where the elements from the first set are larger than the second. You would want to put your largest chars to the right most position, as that minimizes its penalty. So now in these case, you go from largest to smallest and put them in rightmost position. Same is true for the second player

I did something like that, but got WA, could you tell me what's wrong with this code?

CodeI'm not sure if I understood the code correctly but perhaps its this. So first observation is that you will only use the smallest (n+1)/2 elements of the first string and n/2 largest elemets from the second. So you should never add the last element from a set

I should't ever be adding the last element in the set, if it looks that way it is because I sorted the second set and am taking letters from the back

try this case

abcxyzzzz

zyxcbaaaa

Each turn the string should be

- a????????

- az???????

- azb??????

- azby?????

- azbyc????

- azbyc???c

- azbyc??yc

- azbyc?xyc

- azbycxxyc

Ok found the bug, when the letters from the first sit are larger than the second, you should put the largest letters at the back first, and not the smallest at the back

Oh wow that was stupid, thank you for the help!

I followed this strategy, this didn't work for me on testcase 5

reddit abcdef

This strategy gives dfdede but answer is dfdeed

Can someone explain why? is answer for (dexy, abde) is also deed ?

edit[2] : corrected the starting of the output

how can it give efdeed or efdede when there are only 2 e's

the answer should be

first person will use letters: dde second will use letters: fed d?????

df????

dfd???

dfde??

dfde?e

dfdede

My bad, it was dfdede but the answer is dfdeed!, corrected above

My bad, each turn should be

d?????

df????

dfd???

dfd??d

dfd?ed

dfdeed

My solution consisted in the following points :

First, you can know which letters will Egor play, because, as he wants to minimize lexographical order, it's not worth playing its «worst» letters, i.e. he only plays his (n+1)/2 lowest letters.

Same for Igor, who always plays his n/2 biggest letters.

Now, suppose it's Egor playing : his goal will be to minimize the lexicographical order, and thus he wants the lowest letter to be in front. If he has got at least one letter with lower rank than one of Igor's letters, he immediately puts it in front, because it will give him a better score than if Egor plays a largest place instead at the front. However, in the rare case where all his letters are bigger than Igor's one, he wants to play at the back of the string his biggest letter, by a similar argument.

Same for Igor : he will play his biggest letter at the front, except when all his letters are lower than Egor's, in which case he will play his lowest letter at the back.

Implementation isn't really hard, it's simply important not to forget to use sets to quickly retrieve lowest and biggest letters from each player.

How to solve Problem D?

i think graph should be linear line of compressed cliques and vertices of degree 1 and 2. i.e if deg>2 it should form a clique in combination to other nodes. else -1. but not able to code in time.

How to solve B ? My geometry is weaker than the weakest's

B was easier if you looked for which height should you cut, in order to find a triangle of area i/max_area

start with the topmost triangle....now this triangle is similar with the original one and the area of the two is in the ratio 1/n...from here you'll get two equations from where value of h can be easily determined...infact in doing so you'll come to a generalised formula fro each partition

when I will be able to view answers

After systems test is over for that particular solution I guess.

How long is it normally?

You can see the solutions now

[Problem D] I needed just 5 more minutes to solve D. Anyway I solved it as follows:

1. For each city, add itself to its adjacency list.

2. Using hashing, we will use DSU to make clusters of cities with exactly same adjacency.

3. Nodes in a cluster will have the same label value.

4. For each city, modify its adjacency list by replacing all cities in it by their representative i.e for (int v: g[u]) replace v by rep(v).

5. Now if there are more than 2 cities in any adjanceny list, its impossible.

6. Do a dfs, and carefully assign values :)

I hope this is a correct solution.

UPD: Here is the code that I missed by 5 mins.

UPD2: It got AC.

Can anyone please share the idea to solve problem D?

problem C looks complicated any simple solution ?

Very interesting C task :D

Failed to handle cornercases of k={n-3, n-2, n-1} in E on last two minutes of contest having correct ideas, such a pain.....

What is general idea for E?

By picking element from the beginning or from the end of array you simply move its center by 0.5. Thus for fixed array answer is for even length and for odd length.

Maybe I am wrong (got WA on pretest1) but:

if n is even then the answer is

max(a[n/ 2],a[n/ 2 + 1])if n is odd then the answer is

min(max(a[n/ 2 - 1],a[n/ 2 + 1]),a[n/ 2])and this twist with k is very easy to handle. [edit: to slow]

There's this guy in this contest whose id is sepanta and he hacked 35 times successfully..and most amusing fact is the person he hacked is Mr.Fox and he hacked him 35 times!!! the guy sepanta has solved 2 problems (A and B) and is currently standing on 42 :| what the hell???

Don't worry, he'll be banned =)

his rating is now 1772 :| got a +397 boost ....

Give it a time :) It will work out itself

rating: rest in peace

what is the 4th test case of problem C?

Probably, it checks how you process the case when

minof Oleg equalsmaxof Igor.try this case abcxyzzzz zyxcbaaaa Each turn the string shouuld be - a???????? - az???????

- azb??????

- azby?????

- azbyc????

- azbyc???c

- azbyc??yc

- azbyc?xyc

- azbycxxyc

Explain please how can i solve B.

Basically the whole triangle's area is h/2. So, each the n parts' area should be h/2n.

So, for every cut i, you should find h(i) so that the resulting triangle has area i*h/2n. Note that if such a triangle has height h(i), that the base has length (h(i)/h). Therefore, you have to solve (h(i)^2) / 2h = i*h/2n, and the answer is sqrt(i/n)*h.

"if such a triangle has height h(i), that the base has length (h(i)/h)." - can you please explain me why the base has length (h(i)/h) ?

Thanks in advance.

You can use Thales theorem to prove this, since cuts are parallel to the base.

Let b the length of the base you want to compute. Then h(i)/h = b/1.

Thanks

Anyone please help me to solve B?

See above .many coders shared their idea!

thanks.

I tryed to binary search de height. I calculated the basis of the triangle using that :

h/H = b/B so b =B*h/H . ( sorry the bad presentition )

Then i calculated the Area of the triangle using this basis and the height. ( I couldn't solve B , but i think that was the idea)

Quite fast system test today..

Fastest system testing I have ever seen :O

Ultrafast speed of systest <3

I hope they follow same speed in posting editorials :)

Amazingly fast system testing

Fastest System Testing ever !!!

I have not seen so much fast system test before. Impressive.. :)

what's the answer of s = "ddd", t = "aaa" for problem C ?

dad

Thanks, but I got WA for another case :( It hurts I hadn't had time to debug :(

I guess, you didn't got the joke. :( StillFantasy

lol

Why did my code got TLE? Complexity looks fine to me — CODE

the limits is 300000 but you set #define MAX 200001

my bad. Got it correct now

When I submit it with GNU C++ 11 I get a RTE verdict on test 11 instead of a TLE verdict.

How to hack B?

It looks like all successful hacks are made by cheater

Could someone please explain to me why in Test Case 4 (abc aaa), the answer is aab?

I feel the answer should be aba, because Oleg will place 'a' at Position 1, then Igor would place 'a' at Position 3 because he wants the string to be lexicographically large, so Oleg will be left with Position 2 and he'll place b at Position 2.

Thanks in advance!

What if Oleg puts b in 3rd position. It will become ??b. Then it obviously becomes aab

Yes you're right. Thanks a lot!

Oleg should place the 'b' in position 3. Then Igor has to put an 'a' somewhere. Whether it is placed in the first or second location, Oleg will put their 'a' in the other one, giving 'aab'.

Okay. Thanks a lot!

Oleg will place 'b' at 3, and after Igor makes his turn ('a' at place 1 or 2, it is irrelevant), Oleg will place 'a' at last empty space. Answer will become aab, which is smaller than aba.

27081526 In this submit time equal 405ms, but it got verdict TL. How it could possible?

I think it is ML.

Thanks

pls anyone could explain me why the answer of the test Oleg's reddit and Igor's abcdef is dfdeed but not dfdede ? (test 5)

Yeah I am also having same problem :(

d????? -> df???? -> dfd??? -> dfd??d -> dfd?ed -> dfdeed

oh ok tks :)

Can anyone please explain the output of this test case in problem C.

reddit

abcdef

Expected answer is this --> dfdeed

My answer --> dfdede

So, the answer will be of 6 letters. letters for optimal answer- {d,d,e} and {f,e,d} Steps are :- 1)d????? 2)df???? 3)dfd??? 4)dfd??d 5)dfd?ed / dfde?d 6)dfdeed

Fastest system test, and fastest rating update ever, nice round :D

How to make a segment sum tree with range updates and range queries? I'm asking for problem F, to maintain a segment tree for every digit that have sums like that digit was 1. :)

Can problem F be solved with DSU on Segment tree? I tried really hard but still in vain with TLEs. It seems like it can pass in time if I change long long to int, but of course with WA.

I submitted two codes one with long double (code) and one with double code.

double got AC and long double got WA on test 1(though it works perfectly on my machine). I always have a rough time with doubles. Am I missing something? some compiler issues?

it should work with C++14

Why ratings are updated without removing cheaters?

anyone knows how to tag the boss? i mean Mike or any of the Codeforces official???

Goto any contest announcement blog. There will be a thanks to MikeMirzayanov. Copy the name. Then, Hover over the codeforces icon at the top of the comment box. Then, select "User". Paste the name. Click ok and post.

You will see, sir MikeMirzayanov will be tagged. :)

In problem C can someone explain test case:

The answer is:

`dde`

`fed`

`d?????`

`df????`

`dfd???`

`dfde??`

So why would Oleg now play

`dfdee?`

— it is not optimal for him?He should play

`dfde?e`

.So Igor must play:

`dfdede`

For Oleg

`dfdede`

is better than`dfdeed`

?UPDate: got it

Step 4. Igor plays:

`dfd??d`

forceing e on the 4th spot.In the 4th move,

Igor will play

`dfd?e?`

.Now Oleg is forced to put e in the 4th position.

0 d?????

1 df????

2 dfd???

3 dfd??d

4 dfd?ed

5 dfdeed

dfdeed

Now that this round is finished, when will you announce the random playrix t-shirt winners ? KAN

you can run code yourself

He has already posted the handle of winners in reply to his original comment on Playrix Contest Blog.

http://codeforces.com/blog/entry/51920?#comment-359792

hi guys. Mr_Fox is my fake account. sina-ss is my corrently account.

In D tests does not check for overflow in clique check.

This AC submission http://codeforces.com/contest/794/submission/27090233 would fail for almost every graph with n = 65538, m = 98305

Hello guys ! Can someone please help me in problem C. A test case : abc aaa . In the first turn the first player will put 'a' in the first place,then in the second chance the second player can put 'a' either in the second place or in the third place. According to the solutions which have passed they put it in the second place. But i think it will be more optimal to put it in the third place. this way it would be lexicographically bigger from the second player's point of view. Can somebody please explain this to me ?

No. The optimal strategy for the first player is to place his letter 'b' to the last position on the first turn.

As it was written player can place their letter anywhere instead of question marks. So the first turn of Oleg is to place the 'b' at the end. Then, as the biggest letter in Igor's set is 'a' he will place it also at the end. Then, the Oleg's turn is to put 'a' to the first letter. Consequently, the answer is 'aab'.

Could anyone explain me the last input-output example of problem D? Although there is note under the example, I can't catch its point.

basically u need 1 to be the 'neighbour' of 2,3 and 4 but at the same time 2,3,and 4 cannot be the 'neighbour of each other, so therefore the output is "NO"

Got it, thanks!

I am getting TLE for 11 test case for problem C in nlogn. Still it gives TLE. My Submission : http://codeforces.com/contest/794/submission/27085787 Can anybody please tell me reason for that. Thanks

27115362 Here you go.

Basically you TLE because of these lines.

these operation are n^2 instead of n as you recopy the whole string each time. you need to write it as

instead.

Thanks a lot. I thought those two operations were same. But in case of string the complexity would change.

Everybody's rating was back to that before the contest for a moment to ban sepanta.

Anyway, justice was done. Well done, Codeforces!

I tried to solve the problem E.**Leha and security system** https://pastebin.com/haK2wtvr upon submission I am getting run time exception with Exit code is 1

Can anybody help me to figure out what went wrong. Thanks in advance.

problem C Test case 5 input:-reddit abcdef answer:-dfdeed answer acc to me:-dfdede which is lexicographically smaller than and can be possible 1st turn d????? 2nd turn df???? 3rd turn dfd??? 4th turn dfde?? 5th turn dfde?e 6th turn dfdede

please reply am i correct or not